%{ 
   #include <stdio.h>
   enum rets {TITLE=1, BASE, REF, IMG};
   enum stats {STD = 0, I_BASE=1, N_I_R};
   enum rs {generic, image};
   char title[256], img_other[512];
   char *img_src;
   int i_k = 0, t_k = 0, ref;
   unsigned char i_a_tag, found, i_frame; 
%}

%s STD I_BASE I_XMP I_TAG N_I_R I_TITLE I_IMG

SP [ \t\r\n]

a [Aa]
b [Bb]
c [Cc]
d [Dd]
e [Ee]
f [Ff]
g [Gg]
h [Hh]
i [Ii]
j [Jj]
k [Kk]
l [Ll]
m [Mm]
n [Nn]
o [Oo]
p [Pp]
q [Qq]
r [Rr]
s [Ss]
t [Tt]
u [Uu]
v [Vv]
w [Ww]
x [Xx]
y [Yy]
z [Zz]

%%
<STD>"<"{b}{a}{s}{e}{SP}*	BEGIN I_BASE;
<I_BASE>{t}{a}{r}{g}{e}{t}{SP}*={SP}*[^ >]+ { 
   				fprintf (yyout, "<base %s>", yytext); 
				}
<I_BASE>[^<>= '\"\t\r\n]+	return BASE;
<I_BASE>">"			BEGIN STD;
<I_BASE>[<>= '\"\t\r\n]		|
<I_BASE>{h}{r}{e}{f}{SP}*={SP}*	{ /* Discard */ }

<STD>"<"{t}{i}{t}{l}{e}{SP}*">"	{ ECHO; 
   			          BEGIN I_TITLE; 
			       	}
<I_TITLE>.|\n			{ ECHO; 
   				  if (t_k < 255 ) 
     				       title[t_k++] = *yytext; 
				}
<I_TITLE>"<""/"{b}{o}{d}{y}{SP}*">"	{
  					  ECHO;
   					  title[0] = '\0';
   					  t_k = 0; 
				          BEGIN STD;
   					  return TITLE;
					}
<I_TITLE>"<""/"{t}{i}{t}{l}{e}{SP}*">"	{ ECHO;
   					  title[t_k] = '\0';
   					  t_k = 0; 
				          BEGIN STD;
   					  return TITLE;
					}
<N_I_R>\"[^">]*\"		|
<N_I_R>[^> \t\r\n]*	        { if (ref == generic)
				   {
				      BEGIN I_TAG; 
				      return REF;
				   }
   				  else 
     				   {
				      img_src = (char *) realloc (img_src, yyleng + 1);
				      strcpy (img_src, yytext);
				      BEGIN I_IMG;
				   }
				} 
<N_I_R>">"			{
				      yyless (0);
  				      BEGIN I_TAG;
				}
<STD>"<""/"{a}{SP}*">"	        { if (found) 
				   { found = 0;
				     fputs ("</I>", yyout); }
			  	  ECHO; 
				}
<STD>"<"{f}{r}{a}{m}{e}{SP}+	{ ECHO;
				  yyless(6);
   				  i_frame = 1;
   			          BEGIN I_TAG; 
				}
<STD>"<"{a}{SP}+		{ ECHO;
   				  yyless(2);
   				  i_a_tag = 1;
   			          BEGIN I_TAG; 
				}
<STD>"<"[a-zA-Z]+ 		{ ECHO; 
   				  BEGIN I_TAG; 
				}
<STD>"<"{i}{m}{g}{SP}+		{
   				  yyless (4);
   				  BEGIN I_IMG;
				}	   
<I_IMG>{SP}+{s}{r}{c}{SP}*=	{
	   			  ref = image;
	   			  BEGIN N_I_R;
		      		}
<I_IMG>{SP}+{l}{o}{w}{s}{r}{c}{SP}*={SP}*[^ \n\t\r>]+ 	{}
<I_IMG>[^>]	if (i_k < 511) img_other[i_k++] = *yytext;
<I_IMG>">"	{ 
 		  img_other[i_k] = '\0'; 
   		  i_k = 0;
   		  BEGIN STD;
		  return IMG;
		}
<I_TAG>{SP}+{h}{r}{e}{f}[{SP}="]+{m}{a}{i}{l}{t}{o}:[^>]*">"	   |
<I_TAG>{SP}+{h}{r}{e}{f}[{SP}="]+{n}{e}{w}{s}:[^>]*">"  {
				  ECHO;
				  i_a_tag = 0;
				  BEGIN STD;
				}
<I_TAG>{SP}+{h}{r}{e}{f}{SP}*={SP}*				|
<I_TAG>{SP}+{s}{r}{c}{SP}*={SP}*				|  
<I_TAG>{SP}+{b}{a}{c}{k}{g}{r}{o}{u}{n}{d}{SP}*={SP}*	{  
   					  ECHO;
   					  ref = generic;
      					  BEGIN N_I_R; 
					}
<I_TAG>\"([^"]|(\\\"))+\"	ECHO;
<I_TAG>">"	      		{ ECHO;
   				  if (i_frame)
     				     i_frame = 0;
				  if (i_a_tag) 
     				     { i_a_tag = 0; 
				       if (found) 
					  fputs ("<I>", yyout);} 
   				  BEGIN STD;
				}
<STD>"<""/"[a-zA-Z]+{SP}*">"	ECHO;
<STD>"<"{x}{m}{p}{SP}*">"		{ ECHO; 
   					  BEGIN I_XMP;  
   					}
<I_XMP>"<""/"{x}{m}{p}{SP}*">"	{ ECHO; 
   				  BEGIN STD; 
				}
<STD,I_TAG,I_XMP>[^<>= \t\r\n]*	ECHO;
<STD,N_I_R,I_TAG,I_XMP>.|\n	ECHO;
.|\n			{ /* 
			   * This is used to enter STD mode
			   * every time yylex() is called.  
			   */
   			  yyless (0);
			  BEGIN STD;
			}
